/*********************************************

Project : Mini-Roulette
Author  : Karsten Mueller
Date: 31.1.2015

*********************************************/
#define F_CPU 1200000UL
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <avr/interrupt.h>
 
uint8_t LEDs_ddr[6]={0x06,0x03,0x05,0x06,0x03,0x05};
uint8_t LEDs_port[6]={4,1,4,2,2,1};
volatile uint8_t anzeige;
volatile uint8_t animation;
ISR (TIM0_OVF_vect)
{
     static uint8_t counter=0;
     static uint8_t slow=0;
     PORTB=(1<<PB4);
     if(anzeige&(1<<counter)) {
       DDRB=LEDs_ddr[counter];
       PORTB=LEDs_port[counter]|(1<<PB4);
     }
     counter++;
     if(counter>5) {
       counter=0;
      if(animation) {
	  slow++;
	  if(slow==6) {
	    anzeige<<=1;
	    if(anzeige==64) anzeige=1;
	    slow=0;
	  }
	}
     }
     TCNT0=100;//156;
}   
void delay7ms(uint8_t zeit) {
  while(zeit-->0)
    _delay_ms(7);
}
int main(void)
{
  TCCR0A=0;
  TCCR0B=(1<<CS01);
  TIMSK0 = (1<<TOIE0); 
  anzeige=0;
  animation=0;
  sei();
  _delay_ms(400);
  uint16_t wuerfel=0;
  while((PINB&(1<<PB4))) {
    anzeige++;
    _delay_ms(700);
  }
  while(1) {
   anzeige=1;
    animation=1;
    while(!(PINB&(1<<PB4))) {
      wuerfel++;
      if(wuerfel==65520) wuerfel=0;
    }
    animation=0;
    while(anzeige<64) {
      delay7ms(5);
      anzeige<<=1;
    }
    uint8_t counter=1;
    for(counter=0; counter<24+wuerfel%6 ;counter++) {
	anzeige=(1<<(counter%6));
	delay7ms(counter+5);
    }
    cli();
    DDRB=LEDs_ddr[wuerfel%6];
    PORTB=LEDs_port[wuerfel%6]|(1<<PB4);;
    while((PINB&(1<<PB4))) {}
    sei();
  }
}